/*
 * Copyright (c) 2012, Oracle and/or its affiliates. All rights reserved.
 * ORACLE PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/*
 * $Id$
 */
package com.sun.ts.tests.servlet.api.javax_servlet.servletcontext304;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextListener;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletException;

public class TestListener implements ServletContextListener {

    /**
     * Receives notification that the web application initialization
     * process is starting.
     *
     * @param sce The servlet context event
     */
    public void contextInitialized(ServletContextEvent sce) {
        ServletContext context = sce.getServletContext();

        Boolean listener_test = false;
        String LISTENER_TEST = "LISTENER_TEST";

        try {
            context.createListener(com.sun.ts.tests.servlet.api.javax_servlet.servletcontext304.CreateGenericEventListener.class);
        } catch (java.lang.IllegalArgumentException ex) {
            listener_test = true;
            System.out.println("Error creating Listener CreateGenericEventListener: " +
                    ex.getMessage());
        } catch (ServletException exs) {
            System.out.println("Error creating Listener CreateGenericEventListener: " +
                    exs.getMessage());
        }
        context.setInitParameter(LISTENER_TEST, listener_test.toString());
    }

    /**
     * Receives notification that the servlet context is about to be shut down.
     *
     * @param sce The servlet context event
     */
    public void contextDestroyed(ServletContextEvent sce) {
    // Do nothing
    }
}
